*** Replication file for the Williams-Brule "Predictably Unpredictable" BJPS
* 9-28-12

*** NOTE: to replicate, you must run the commands between the lines of asterisks before running the other commands!
* While this do file recreates the figures, in order to exactly replicate the figures you must run the R file.

use "C:\Users\williamslaro\Documents\Research\Projects\Conflict and Elections\Spring 2010\Hetreg\BJPS\Final Version\Replication\Williams-Brule Replication Data.dta", clear

********************************************************************************
*** PROGRAMS
********************************************************************************
capture program drop hetreg
program define hetreg
version 7
	args 1nf theta1 theta2
	quietly replace `1nf'=-(1/2)*ln(2*_pi)-(1/2)*ln(exp(`theta2'))-(1/(2*(exp(`theta2'))))*($ML_y1-`theta1')^2
end

capture program drop my_het
program define my_het, rclass
	syntax, name(string)
	htest
	white
	hettest `name'
end

capture program drop me
program define me
matrix b=e(b) 
matrix V=e(V)
scalar b1=b[1,6]
scalar b2=b[1,5]
scalar b3=b[1,7]
scalar varb1=V[6,6] 
scalar varb3=V[7,7]
scalar covb1b3=V[6,7] 

capture drop vectaxis me lower_ci upper_ci lower_ci_90 upper_ci_90
qui gen vectaxis = .
qui gen me = .
qui gen lower_ci = .
qui gen lower_ci_90 = .
qui gen upper_ci = .
qui gen upper_ci_90 = .
local b = 1

quietly foreach i of numlist 0 1 {
	local n = 1
	qui gen conb = b1 + (b3*(`i'))
	local conse = sqrt(varb1+varb3*((`i')^2)+2*covb1b3*(`i'))
	qui gen x=1.96*`conse'
	qui gen x_90 = 1.65*`conse'
 	qui gen upper=conb+x
	qui gen lower=conb-x
	qui gen upper_90 = conb+x_90
	qui gen lower_90 = conb-x_90
	qui sum conb
		local me = `r(mean)'
		replace me = `me' in `b'
	qui sum lower 
		local lower_ci = `r(mean)'
		replace lower_ci = `lower_ci' in `b'
	qui sum lower_90 
		local lower_ci_90 = `r(mean)'
		replace lower_ci_90 = `lower_ci_90' in `b'
	qui sum upper
		local upper_ci = `r(mean)'
		replace upper_ci = `upper_ci' in `b'
	qui sum upper_90
		local upper_ci_90 = `r(mean)'
		replace upper_ci_90 = `upper_ci_90' in `b'
	noisily di
	noisily di
	noisily di as result "The marginal effect for time left in CIEP is " `me'
	noisily di
	noisily di as result "The 95% confidence interval is " `lower_ci' 	"	and		"	`upper_ci'
	noisily di
	noisily di as result "The 90% confidence interval is " `lower_ci_90'   "    and      " `upper_ci_90' 
	noisily di
	noisily di as result "The modifying variable is = 	" `i'
	noisily di 
	noisily di
	capture drop conb* x* upper upper_90 lower lower_90
	replace vectaxis = `i' in `b'
	local b = `b' + 1
	local n = `n' + 1
}
capture drop vectaxis me lower_ci upper_ci lower_ci_90 upper_ci_90
end

capture program drop me2
program define me2
matrix b=e(b) 
matrix V=e(V)
scalar b1=b[1,5]
scalar b2=b[1,6]
scalar b3=b[1,7]
scalar varb1=V[5,5] 
scalar varb3=V[7,7]
scalar covb1b3=V[5,7] 

capture drop vectaxis me lower_ci upper_ci lower_ci_90 upper_ci_90
qui gen vectaxis = .
qui gen me = .
qui gen lower_ci = .
qui gen lower_ci_90 = .
qui gen upper_ci = .
qui gen upper_ci_90 = .
local b = 1

quietly foreach i of numlist 0(20)100 {
	local n = 1
	qui gen conb = b1 + (b3*(`i'))
	local conse = sqrt(varb1+varb3*((`i')^2)+2*covb1b3*(`i'))
	qui gen x=1.96*`conse'
	qui gen x_90 = 1.65*`conse'
 	qui gen upper=conb+x
	qui gen lower=conb-x
	qui gen upper_90 = conb+x_90
	qui gen lower_90 = conb-x_90
	qui sum conb
		local me = `r(mean)'
		replace me = `me' in `b'
	qui sum lower 
		local lower_ci = `r(mean)'
		replace lower_ci = `lower_ci' in `b'
	qui sum lower_90 
		local lower_ci_90 = `r(mean)'
		replace lower_ci_90 = `lower_ci_90' in `b'
	qui sum upper
		local upper_ci = `r(mean)'
		replace upper_ci = `upper_ci' in `b'
	qui sum upper_90
		local upper_ci_90 = `r(mean)'
		replace upper_ci_90 = `upper_ci_90' in `b'
	noisily di
	noisily di
	noisily di as result "The marginal effect for executive is " `me'
	noisily di
	noisily di as result "The 95% confidence interval is " `lower_ci' 	"	and		"	`upper_ci'
	noisily di
	noisily di as result "The 90% confidence interval is " `lower_ci_90'   "    and      " `upper_ci_90' 
	noisily di
	noisily di as result "The modifying variable is = 	" `i'
	noisily di 
	noisily di
	capture drop conb* x* upper upper_90 lower lower_90
	replace vectaxis = `i' in `b'
	local b = `b' + 1
	local n = `n' + 1
}
capture drop vectaxis me lower_ci upper_ci lower_ci_90 upper_ci_90
end
******************************************************************************


**********************************************************************************
** Replication
**********************************************************************************
*** Test to determine if fixed effects are needed in the mean and variance equations.
reghv pervote mid_count_h lagpervote coalition executive ciep_perc exec_ciep grow une_lag inf_diff cc1-cc23 /*
*/	, var(mid_count_h cc1-cc23) nolog
test cc1 = cc2 = cc3 = cc4 = cc5 = cc6 = cc7 = cc8 = cc9 = cc10 = cc11 = cc12 = cc13 = cc14 = cc15 = cc16 = cc17 = cc18 = cc19 = cc20 = cc21 = cc22 = cc23 = _cons = 0
test [lp_lnvar]cc1 = [lp_lnvar]cc2 = [lp_lnvar]cc3 = [lp_lnvar]cc4 = [lp_lnvar]cc5 = [lp_lnvar]cc6 = [lp_lnvar]cc7 = [lp_lnvar]cc8 = [lp_lnvar]cc9 = [lp_lnvar]cc10 = [lp_lnvar]cc11 = [lp_lnvar]cc12 = [lp_lnvar]cc13 = [lp_lnvar]cc14 = [lp_lnvar]cc15 = [lp_lnvar]cc16 = [lp_lnvar]cc17 = [lp_lnvar]cc18 = [lp_lnvar]cc19 = [lp_lnvar]cc20 = [lp_lnvar]cc21 = [lp_lnvar]cc22 = [lp_lnvar]cc23 = [lp_lnvar]_cons = 0


*** Replication of Table 1
reghv pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff /*
*/	, var(mid_count_h cc1-cc23) robust cluster(ccode)  nolog
me
me2



**********************************************************************************
** Descriptive Statistics
**********************************************************************************
preserve
	quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff
	keep if e(sample)
	sum pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff
	tab majority if e(sample)
	tab coalition if e(sample)
	tab executive if e(sample)
	sum mid_count_h mid_count_h_6, det
	foreach i of varlist mid_count_h mid_count_h_6 {
		tab `i'
	}
restore	
		
preserve
	quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff
	keep if e(sample)
	sort ccode ts
	drop if (ccode==ccode[_n-1] & ts==ts[_n-1])
	collapse (count) no_elections = ts, by(countryname)
	format no_elections %8.0g
	egen total = total(no_elections)
	list countryname no_elections total
restore
	
preserve
	quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff
	keep if e(sample)
	collapse (count) obs = elecdate, by(countryname)
	egen total = total(obs)
	list countryname obs total
restore

preserve
	quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff
	keep if e(sample)
	drop if (ccode==ccode[_n-1] & ts==ts[_n-1])
	list countryname ts, sepby(countryname)
restore

preserve
	quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff
	keep if e(sample)
	sort ccode ts
	drop if (ccode==ccode[_n-1] & ts==ts[_n-1])
	recode mid_count_h_6 (2/max=1)
	recode mid_count_h (2/max=1)
	collapse (sum) no_h = mid_count_h no_h_6 = mid_count_h_6, by(countryname)
	egen total_h = total(no_h)
	egen total_h_6 = total(no_h_6)
	list countryname no_h no_h_6 total_h total_h_6
restore

******************************************************************************
*** FIGURES
******************************************************************************

********************************************************************************
** Figure 2a
** Across real GDP per capita growth (%)
** Rutemiller and Bowers 1968: 554
********************************************************************************
use "C:\Users\williamslaro\Documents\Research\Projects\Conflict and Elections\Spring 2010\Hetreg\BJPS\Final Version\Replication\Williams-Brule Replication Data.dta", clear

quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff cc1-cc23
keep if e(sample)
local df = e(df_r)

reghv pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff /*
*/	, var(mid_count_h cc1-cc23) robust cluster(ccode)  nolog
mat list e(b)
mat list e(V)

mat V = e(V)
capture drop xb stdp
predict xb, xb
predict stdp, stdp
capture gen cons = 1
gen yhat = .
gen se_het = .
gen se = .
gen vectaxis = .
mkmat mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff cons, matrix(x)
mkmat mid_count_h cc1-cc23 cons, matrix(v)
mkmat pervote, matrix(y)
matrix beta = e(b)
matrix b = beta[1,1..11]
matrix g = beta[1,12..36]
matrix b = b'
matrix g = g'
matrix xprime = x'
matrix xprime_x = xprime*x
matrix xprime_x_inv = inv(xprime_x)

local b = 1

* Now, do a loop with the predicted value and the confidence intervals
* Growth
quietly foreach i of numlist -1.8(.1)9.8 {
	mat x0 = (3\25.5\1\0\1\17.9\9.7\\`i'\5.97\1.11\1)
	mat g0 = (3\0\0\0\0\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\1)
	mat x0_prime = x0'
	mat g0_prime = g0'
	mat p = x0_prime*b
	mat sigma_het = g0_prime*g
	mat sigma_het_2 = exp(sigma_het[1,1])
	mat var_het = sigma_het_2*(x0_prime*xprime_x_inv*x0)
	mat se_het = sqrt(var_het[1,1])

	replace yhat = p[1,1] in `b'
	replace se_het = se_het[1,1] in `b'
	
	mat g1 = (0\0\0\0\0\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\1)
	mat g1_prime = g1'	
	mat sigma = g1_prime*g
	mat sigma_2 = exp(sigma[1,1])
	mat var = sigma_2*(x0_prime*xprime_x_inv*x0)
	mat se = sqrt(var[1,1])
	
	replace se = se[1,1] in `b'
	replace vectaxis = `i' in `b'
	local b = `b' + 1
}


gen lo_90 = yhat - (1.65*se)
gen hi_90 = yhat + (1.65*se)
gen lo_het_90 = yhat - (1.65*se_het)
gen hi_het_90 = yhat + (1.65*se_het)

twoway (line yhat vectaxis, clwidth(thick)) (line lo_90 vectaxis, clpattern(dash)) (line hi_90 vectaxis, clpattern(dash)) /*
*/	(line lo_het_90 vectaxis, clpattern(dash) clwidth(thick)) (line hi_het_90 vectaxis, clpattern(dash) clwidth(thick)) /*
*/	, ytitle("Vote Share") xtitle("Real GDP Per Capita Growth (%)") legend(off)

preserve
	keep if yhat !=. 
	outsheet yhat - hi_het_90 using "yhat_gdp.csv", comma replace nolabel
restore

********************************************************************************
** Figure 2b
** Across unemployment
** Rutemiller and Bowers 1968: 554
********************************************************************************
use "C:\Users\williamslaro\Documents\Research\Projects\Conflict and Elections\Spring 2010\Hetreg\BJPS\Final Version\Replication\Williams-Brule Replication Data.dta", clear

**** Predicted values and standard errors
quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff cc1-cc23
keep if e(sample)
local df = e(df_r)

reghv pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff /*
*/	, var(mid_count_h cc1-cc23) robust cluster(ccode)  nolog
mat list e(b)
mat list e(V)

mat V = e(V)
capture drop xb stdp
predict xb, xb
predict stdp, stdp
capture gen cons = 1
gen yhat = .
gen se_het = .
gen se = .
gen vectaxis = .
mkmat mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff cons, matrix(x)
mkmat mid_count_h cc1-cc23 cons, matrix(v)
mkmat pervote, matrix(y)
matrix beta = e(b)
matrix b = beta[1,1..11]
matrix g = beta[1,12..36]
matrix b = b'
matrix g = g'
matrix xprime = x'
matrix xprime_x = xprime*x
matrix xprime_x_inv = inv(xprime_x)

local b = 1

* Now, do a loop with the predicted value and the confidence intervals
* Unemployment
quietly foreach i of numlist 1(.1)14 {
	mat x0 = (3\25.5\1\0\1\17.9\9.7\3.03\\`i'\1.11\1)
	mat g0 = (3\0\0\0\0\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\1)
	mat x0_prime = x0'
	mat g0_prime = g0'
	mat p = x0_prime*b
	mat sigma_het = g0_prime*g
	mat sigma_het_2 = exp(sigma_het[1,1])
	mat var_het = sigma_het_2*(x0_prime*xprime_x_inv*x0)
	mat se_het = sqrt(var_het[1,1])

	replace yhat = p[1,1] in `b'
	replace se_het = se_het[1,1] in `b'
	
	mat g1 = (0\0\0\0\0\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\1)
	mat g1_prime = g1'	
	mat sigma = g1_prime*g
	mat sigma_2 = exp(sigma[1,1])
	mat var = sigma_2*(x0_prime*xprime_x_inv*x0)
	mat se = sqrt(var[1,1])
	
	replace se = se[1,1] in `b'
	replace vectaxis = `i' in `b'
	local b = `b' + 1
}


gen lo_90 = yhat - (1.65*se)
gen hi_90 = yhat + (1.65*se)
gen lo_het_90 = yhat - (1.65*se_het)
gen hi_het_90 = yhat + (1.65*se_het)

twoway (line yhat vectaxis, clwidth(thick)) (line lo_90 vectaxis, clpattern(dash)) (line hi_90 vectaxis, clpattern(dash)) /*
*/	(line lo_het_90 vectaxis, clpattern(dash) clwidth(thick)) (line hi_het_90 vectaxis, clpattern(dash) clwidth(thick)) /*
*/	, ytitle("Vote Share") xtitle("Unemployment (%)") legend(off)

preserve
	keep if yhat !=. 
	outsheet yhat - hi_het_90 using "yhat_unem.csv", comma replace nolabel
restore


********************************************************************************
** Figure 2c
** Across first differenced inflation
** Rutemiller and Bowers 1968: 554
********************************************************************************
use "C:\Users\williamslaro\Documents\Research\Projects\Conflict and Elections\Spring 2010\Hetreg\BJPS\Final Version\Replication\Williams-Brule Replication Data.dta", clear

**** Predicted values and standard errors
quietly reg pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff cc1-cc23
keep if e(sample)
local df = e(df_r)

reghv pervote mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff /*
*/	, var(mid_count_h cc1-cc23) robust cluster(ccode)  nolog
mat list e(b)
mat list e(V)

mat V = e(V)
capture drop xb stdp
predict xb, xb
predict stdp, stdp
capture gen cons = 1
gen yhat = .
gen se_het = .
gen se = .
gen vectaxis = .
mkmat mid_count_h lagpervote majority coalition executive ciep_perc exec_ciep grow une_lag inf_diff cons, matrix(x)
mkmat mid_count_h cc1-cc23 cons, matrix(v)
mkmat pervote, matrix(y)
matrix beta = e(b)
matrix b = beta[1,1..11]
matrix g = beta[1,12..36]
matrix b = b'
matrix g = g'
matrix xprime = x'
matrix xprime_x = xprime*x
matrix xprime_x_inv = inv(xprime_x)

local b = 1

* Now, do a loop with the predicted value and the confidence intervals
* First differenced inflation
quietly foreach i of numlist -3.2(.1)3.8 {
	mat x0 = (3\25.5\1\0\1\17.9\9.7\3.03\5.97\\`i'\1)
	mat g0 = (3\0\0\0\0\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\1)
	mat x0_prime = x0'
	mat g0_prime = g0'
	mat p = x0_prime*b
	mat sigma_het = g0_prime*g
	mat sigma_het_2 = exp(sigma_het[1,1])
	mat var_het = sigma_het_2*(x0_prime*xprime_x_inv*x0)
	mat se_het = sqrt(var_het[1,1])

	replace yhat = p[1,1] in `b'
	replace se_het = se_het[1,1] in `b'
	
	mat g1 = (0\0\0\0\0\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\1)
	mat g1_prime = g1'	
	mat sigma = g1_prime*g
	mat sigma_2 = exp(sigma[1,1])
	mat var = sigma_2*(x0_prime*xprime_x_inv*x0)
	mat se = sqrt(var[1,1])
	
	replace se = se[1,1] in `b'
	replace vectaxis = `i' in `b'
	local b = `b' + 1
}


gen lo_90 = yhat - (1.65*se)
gen hi_90 = yhat + (1.65*se)
gen lo_het_90 = yhat - (1.65*se_het)
gen hi_het_90 = yhat + (1.65*se_het)

twoway (line yhat vectaxis, clwidth(thick)) (line lo_90 vectaxis, clpattern(dash)) (line hi_90 vectaxis, clpattern(dash)) /*
*/	(line lo_het_90 vectaxis, clpattern(dash) clwidth(thick)) (line hi_het_90 vectaxis, clpattern(dash) clwidth(thick)) /*
*/	, ytitle("Vote Share") xtitle("First Differenced Inflation") legend(off)

preserve
	keep if yhat !=. 
	outsheet yhat - hi_het_90 using "yhat_inf.csv", comma replace nolabel
restore



********************************************************************************
** Figure 1
** Predicted error SD across the number of hostile disputes
** Rutemiller and Bowers 1968: 554
********************************************************************************

capture drop lo_90 hi_90 

gen sigma_2 = .
gen sigma_sd = .
gen sigma_2_se = .

local c = 25		/* row element of constant in variance equation */
local ex = 11		/* row element of cc10 == 1, Spain in variance equation*/

local mv = 12		/* row element of MID in variance-covariance matrix */
local exv = (`ex' + 11)		/* row element of country in variance-covariance matrix */
local cv = 36		/* row element of constant in variance-covariance matrix */
local b = 1

* Now, do a loop with the predicted value and the confidence intervals
quietly foreach i of numlist 0(1)5 {
	replace sigma_2 = exp(g[`c',1]+(g[`ex',1])+(`i'*g[1,1])) in `b'
	replace sigma_sd = sqrt(sigma_2) in `b'
	local t = V[`cv',`cv'] + (2*`i'*V[`mv',`cv']) + (`i'^2*V[`mv',`mv']) + (2*1*V[`exv',`cv']) + (1^2*V[`exv',`exv'])
	replace sigma_2_se = sqrt(`t') in `b'
	replace vectaxis = `i' in `b'
	local b = `b' + 1
}

gen lo_90 = sigma_sd - (1.65*sigma_2_se)
gen hi_90 = sigma_sd + (1.65*sigma_2_se)
gen lo_95 = sigma_sd - (1.96*sigma_2_se)
gen hi_95 = sigma_sd + (1.96*sigma_2_se)


preserve
	keep if sigma_2 !=. 
	outsheet sigma_2 - hi_95 vectaxis using "sigma.csv", comma replace nolabel
restore


twoway (line sigma_sd vectaxis) (line lo_90 vectaxis, clpattern(dash)) (line hi_90 vectaxis, clpattern(dash)) /*
*/	, ytitle("Sigma") xtitle("Number of Hostile Disputes") legend(off)
